# Ve na danm dku za tmto symbolem nen pedmtem vykonvn pkaz 
# takto si tedy pi poznmky k tomu, co jsem zamlel
# (vkldejte klvesovou zkratkou Alt + 35)

###### R poprv (projektov = potebuji box-plot)######
#### Musme zvolit pracovn adres####
# lomtka jsou klasick a ne opan,
# pkaz je setwd

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

#### Musme mt data####
# Data jsou ty typ: http://portal.matematickabiologie.cz/index.php?pg=zaklady-informatiky-pro-biology--vypocetni-matematicke-systemy--vyuka-jazyka-r--prvni-setkani-s-jazykem-r--datove-typy-objektu

# "Nejjednodum" zpsobem jak data zskat, je import z MS Excel.
# Data lze pipravit i R v podstan nekonen mnoha zpsoby,
# pt si ukeme principy), pro zatek je ale o hodn 
# jednodu pout MS Excel :-) 
# Import nen pln automaticky dostupn, ale je k tomu nutno mt nainstalovan 
# balky (packages).
# K instalacm balk se dostaneme asem, ale instalaci balk nutnch k monosti importu 
# dat z MS Excel natst dl nov u RStudio intuitivn. 
# Packages je vdy teba aktivovat pkazem library - zrovna pro import z MS Excel 
# to nen teba, protoe to RStudio dl samo, ale vukov si to vyzkouejme.

library(readxl)

####Objekty
# data tvo objekty - typy objekt viz prezentace
# R si tyto objekty pamatuje pod nzvem, definuj se pomoc "<-" 
# (vkldejte klvesovou zkratkou Alt + doln podtrtko)

pro_boxplot <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/data_mkv1_1.xlsx")
# data <- read_excel("E:/R/data_mkv1_1.xlsx") # cesta k datm na Vaich flekch

# pro_boxplot je mnou zvolen nzev pro objekt dat,
# read_excel je pkaz z package readxl a umouje import dat z MS Excel,
# v zvorce a uvozovkch je cesta k souboru,
# vsledek m charakter typu dat data.frame, kter zahrnuje data dvou sloupc, 
# jmna sloupc a oznaen dk - je to tedy komplikovan struktura dat
# Jak to vm? - Pokud nevme, tak pouijeme dotaz na typ dat - class 

class(pro_boxplot)

####A konen graf####
# pouiji funkci boxplot

boxplot(pro_boxplot)

# V prav doln sti v poloce Plot se zobraz vsledek.

####Atributy####
# Vsledek se nm moc nelb = nen to, co jsme chtli, opt plat,
# zpsob, jak doclit poadovanho stavu je nekonen mnoho. My se 
# na een naume principy prce s atributy.
# Pkazy maj atributy - je teba dohledat v helpu, ten se vol pomoc 
# otaznku a nzvu pkazu nebo pkazu help

?boxplot
help(boxplot)

# npovda se zobraz v okn vpravo dole

#v podstat budeme pouvat tzv low-level funkce, pomoc nich jsme schopni
# v grafu cokoliv zmnit a cokoliv do nj doplnit

# nejprve vlome jen poadovan sloupce z tatov tabulky

boxplot(pro_boxplot$c1, pro_boxplot$c4)

# nzvy jsou divn, mli bychom je popsat

boxplot(pro_boxplot$c1, pro_boxplot$c4, names=c("jaro", "podzim"))

# te bychom mli popsat osy

boxplot(pro_boxplot$c1, pro_boxplot$c4, names=c("jaro", "podzim"), xlab="odbr", ylab="konduktivita [uS/cm]")

# mohli bychom napsat nzev

boxplot(pro_boxplot$c1, pro_boxplot$c4, names=c("jaro", "podzim"), main="Konduktivita na raelinitch", xlab="odbr", ylab="konduktivita [uS/cm]")

# pro nespokojence lze sestavit i sloitj konstrukci a pohrt si s barvami a liniemi
# nejprve musme vytvoit nov objekt, kterm bude seznam (list),
# pojmunuji ho bx.barvy - grafiku pak mnm pomoc funkce bxp()

bx.barvy <- boxplot(pro_boxplot$c1, pro_boxplot$c4, names=c("jaro", "podzim"))

bxp(bx.barvy, boxfill = "lightblue", medcol = "red", medlty="dashed", main="Konduktivita na raelinitch", xlab="odbr", ylab="konduktivita [uS/cm]")

# zkladn typy grafickch prav jsou nap. zde: http://portal.matematickabiologie.cz/index.php?pg=zaklady-informatiky-pro-biology--vypocetni-matematicke-systemy--vyuka-jazyka-r--grafika-v-r--funkce-par


# mno a nakonec bychom mohli zskat i textov vstupn hodnoty, 
# k tomu pouiji pkaz (boxplot())

(boxplot(pro_boxplot$c1, pro_boxplot$c4, names=c("jaro", "podzim"), main="Konduktivita na raelinitch", xlab="odbr", ylab="konduktivita [uS/cm]"))




###### R podruh (mraven prce = prce s daty a objekty)######
# Pikrome k nepopulrn sti  - obecn prci s daty, nejprve se skalry a vektory.

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

####Kalkulaka####

13*5

11^5

(20-6+2)/2

# pehled opertor je zde: http://portal.matematickabiologie.cz/index.php?pg=zaklady-informatiky-pro-biology--vypocetni-matematicke-systemy--vyuka-jazyka-r--konstanty-operatory-a-matematicke-vypocty


####Run tvorba vektoru####
# na pkladu vektoru si ukeme zkladn operace, kter lze analogicky provdt
# i u talch typ objekt (ty jsme obecn poznali minule)
# vektor mohu nejlpe vytvoit funkc c

c1 <- c(50, 14, 57, 145, 79, 9, 357, 63, 48, 10, 83, 40, 10, 10, 18, 61, 19, 38, 98, 93, 44)

# zadnm nzvu vektoru se provede vpis jeho hodnot 

c1

# Zadejme vektor neselnch znak (text je vdy v uvozovkch)

veg <- c("typ3", "typ2", "typ3", "typ2", "typ2", "typ2", "typ1", "typ3", "typ2", "typ2", "typ3", "typ3", "typ2", "typ2", "typ1", "typ2", "typ2", "typ2", "typ3", "typ1", "typ3")
veg

# Je-li to nutn, lze ji vytvoen vektory spojovat, opt pomoc funkce c

veg_c1 <- c(veg,c1)
veg_c1

# . . . vimte si, e vektor veg_c1 je textov.

# tento vektor je k niemu - jen jsme si ukzali princip, take jej smame,
# k tomu slou funkce rm

rm(veg_c1)

# Generovat lze posloupnosti sel nebo nhodn sla - ble zde: http://portal.matematickabiologie.cz/index.php?pg=zaklady-informatiky-pro-biology--vypocetni-matematicke-systemy--vyuka-jazyka-r--vektory--zakladni-prikazy-tvorba-vektoru

# Hodnoty vektoru mu pojmenovat (k tomu pouiji pouiju vektor textovch hodnot a 
# opt funkce c). Pouil jsem sla jako text

names(c1) <- c("1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21")
c1

# Mal kontrola (funkce names() zobraz jmna)
names(c1)


####Vbry z vektor####
# Vbry vdy uvdm v hranatch zvorkch.
# Vbry jen nezobrazuji, jak si ukame v tto sekci, ale pouvm pro vpoty (to si
# ukeme dle)
# Selektuji podle poad hodnoty na zklad poad - nsledn syntaxe zobraz
# 2. daj ve vektoru (hodnota je 14, jmno je "2")

c1[2]

#  Chci-li jich selektovat vce, pak musm pout funkci c - nsledn syntaxe zobraz
# 2. a 5. daj ve vektoru 

c1[c(2,5)]

#  Chci-li selektovat daje od-do, pak pouiji dvojteky - nsledn syntaxe zobraz
# 2. a 5. daj ve vektoru 

c1[2:5]

# Mohu ale selektovat od uritho poad a do konce

c1[5:length(c1)]

# Hodnoty mohu vybrat i podle jmna. e jde o jmno dm R navdom uvedenm 
# do uvozovek

c1[c("20")]
c1[c("20", "21")]

# Vbr lze pout i k prav vektor, napklad k mazn zznam. Nslednou syntax 
# smau ve vektoru c1 posledn poloku a vsledek ulom jako nov vektor c1x

c1x <- c1[-21]
c1x

# c1x smau, protoe byl jen na ukzku 

rm(c1x)


####Charakteristiky polohy a variability v R####
# Prmr

mean(c1)

# Medin

median(c1)

# Minimum, maximum

min(c1)
max(c1)

# Ordinln popisn statistika (minimum, doln kvartil, medin, horn kvartil, maximum)

quantile(c1)

# Smrodatn ochylka

sd(c1)

# Rozptyl

var(c1)

# Funkce mohu libovoln kombinovat, jako v MS Excel, SD si mohhu vypotat z rozptylu

sqrt(var(c1))

# Mon elegantnj (protoe slo je uloeno) je jt pes uloen skalru

varc1 <- var(c1)
sqrt(varc1)




###### R potet (prce s "tabulkami")######

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

####Matice####
# Vytvom si vektor c1 z pedchoz lekce

c1 <- c(50, 14, 57, 145, 79, 9, 357, 63, 48, 10, 83, 40, 10, 10, 18, 61, 19, 38, 98, 93, 44)
c1

# UPOZORNN - matice me mt vektory jen jednoho typu, proto si vytvome 
# dal seln vektor - c4

c4 <- c(80, 102, 142, 92, 102, 72, 363, 51, 102, 113, 159, 127, 163, 60, 63, 99, 208, 549, 151, 144, 65)
c4

# Matici (pokud ji neimportujeme), nejastji tvome spojenm vektor funkc cbind, 
# kter tvo matici po sloupcch (po dcch je to funkce rbind)

mat1 <- cbind(c1,c4)
mat1
class(mat1)

# Matici mu snadno transponovat (otoit) funkc t

mat1_t <- t(mat1)
mat1_t
rm(mat1_t)

# Hodnoty v matici vybrm analogicky vektorm.
# dek je na prvn pozici a sloupec na druh,
# tj. [3,2] mi vybere slo na tetm dku a v prvnm sloupci

mat1[3,2]

# [1,] mi vybere prvn dek a vechny sloupce a [,2] mi vybere druh sloupec 
# a vechny dky:

mat1[1, ]
mat1[ ,2]


# Matici mohu vytvoit  i jako przdnou funkc matrix()

mat2 <- matrix(data = NA, nrow = 21, ncol = 2)
mat2

# . . . a nsledn ji "nakrmit" sly z vektrortakto naplnm matici sly z vektor:

mat2[,1] <- c1
mat2[,2] <- c4
mat2

# Sloupce matice si pro pehlednost mu pojmenovat funkc colnames()

colnames(mat2) <- c("jaro","podzim")
mat2 #podvejme se na ni

# Analogicky lze pojmenovat dky matice funkc rownames(),
# a to bu run, jak jsme si to ukzali v ppad colnames nebo pomoc 
# dat z vektoru, zde si zalome vektor plocha

plocha <- c("1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21")
rownames(mat2) <- plocha
mat2 #podvejme se na ni


####Pole####
# pole je vcerozmrn matice a tvo se pomoc funkce array() - my ji 
# v zkladnm kurzu pouvat nebudeme

####Datov tabulka####
# Datovou tabulku (data frame) budete hodnotit astji ne matici, protoe 
# budete mt k dispozici asto seln i textov daje.
# Prce je analogick maticm
# pro prci ale nejprve vytvome faktor s vegetanm typem:

veg <- c("typ3", "typ2", "typ3", "typ2", "typ2", "typ2", "typ1", "typ3", "typ2", "typ2", "typ3", "typ3", "typ2", "typ2", "typ1", "typ2", "typ2", "typ2", "typ3", "typ1", "typ3")
veg

# Nejastji budete tvoit datovou tabulku spojenm vektor funkc data.frame,
# vytvome si tabulku, kde bude slo plochy, vegetan typ a jarn a podzimn men:

dat_tab1 <- data.frame(plocha,veg,c1,c4)
dat_tab1 #podvme se na ni
colnames(dat_tab1) <- c("plocha","vegetacni_typ", "jaro", "podzim")
dat_tab1 #podvme se na ni
rownames(dat_tab1) <- plocha
dat_tab1 #podvme se na ni

# Jak piadit nov sloupec je mono nkolika zpsoby, shrnuty jsou zde:
# http://portal.matematickabiologie.cz/index.php?pg=zaklady-informatiky-pro-biology--vypocetni-matematicke-systemy--vyuka-jazyka-r--datove-tabulky-a-seznamy--funkce-pro-manipulaci-s-datovymi-tabulkami-a-seznamy
# nejastji asi pouijete nsledujc formuli, j nakonec piadme sloupec za letn men:

dat_tab1$leto <- c(94, 64, 63, 124, 76, 65, 325, 20, 26, 69, 118, 85, 40, 90, 38, 77, 69, 80, 96, 129, 60)
dat_tab1 #podvme se na ni

# Tm jsme vyeili pilepen sloupce, co kdy ale potebuji propojit tabulky pes relaci, tedy analogii
# funkce SVYHLEDAT z MS Excel?
# Spojen tabulek se e rzn, efektivn monost je pouit funkce merge().
# Pklad: 2 lokality, na kad 3 plochy. V kad jsem zaznamenal vskyt Drosera 
# rotundifolia. Mm tabulku ploch s vskytem D.r. a tabulku pazen ploch 
# k lokalit a informaci o managementu. 
# Chci piadit k rostlinm management lokalit a nedlat to run.
# nejpve vytvom ob datov tabulky a nsledn se je pokusm spojit

plot_data <- data.frame(plot = c(2, 4, 6, 1, 3, 5), drosera = c("Y", "N", "N", "Y","Y","Y"))
plot_data #podvme se na ni

locality_data <- data.frame(plot = c(1, 2, 3, 4, 5, 6), locality = c(rep("loc1", 3), rep("loc2", 3)), management = c(rep("koseno",3), rep("nekoseno",3)))
locality_data #podvme se na ni

# ... no a konen zadm funkci merge(), kterou ob tabulky propojm (pes promnnou plot - k tomu slou
# atribut by) a vsledek bude uloen v objektu s nzvem sum:

sum <- merge(x = plot_data, y = locality_data, by = "plot", all = TRUE)
sum

# vce naleznete zde: http://portal.matematickabiologie.cz/index.php?pg=zaklady-informatiky-pro-biology--analyza-dat-v-r--uprava-a-transformace-dat-v-r--spojovani-datovych-tabulek

# Na rozdl od matice sloupec v data.frame mu zvolit pomoc symbolu $.
# Zrove si vimnte, e vegetan typ je faktor - protoe textov etzec 
# datov tabulka povauje automaticky za faktor (= m identitifikovan Levels):

dat_tab1$vegetacni_typ
is.factor(dat_tab1$vegetacni_typ)

# Pokud chci vytvoit kategoriln promnnou z selnho etzce, tak 
# to musm udlat pomoc funkce as.factor().
# Napklad pro plocha by syntaxe vypala takto
dat_tab1$plocha <- as.factor(dat_tab1$plocha)
# dlat to ale nebudeme, protoe plocha u faktor je

is.factor(dat_tab1$plocha) #testujeme, jestli je sloupec plocha opravdu faktor

# Sumrn data datov tabulky volme funkc summary()

summary(dat_tab1)

# Datov tabulka se ale d vytvoit i jednoduchou konverz matice

dat_tab2 <- as.data.frame(mat2)
class(dat_tab2) #podvme se na typ

# Funguje to pekvapiv i obrcen, tj. z datov tabulky na matrix (matici) 

mat3 <- as.matrix(dat_tab1)
class(mat3) #podvme se na typ

# nicmn s hledem na chakter matice jsou vechny daje textov

mat3 #podvme se na daje

# Selekce jednotlivch hodnot v datov tabulce, ale i v matici, mu provst 
# na zklad definovanch podmnek

vyber1 <- dat_tab1[dat_tab1$jaro>60,] 
vyber1 #podvme se na nj
vyber2 <- dat_tab1[dat_tab1$podzim<100,]
vyber2 #podvme se na nj

# . . . a te to meme spojit - "and" se dl pomoc &

vyber3 <- dat_tab1[dat_tab1$jaro>60 & dat_tab1$podzim<100,]
vyber3  #podvme se na nj

# pokud potebujete vybrat pmo hodnotu, muste dt dvojit rovntko ==

vyber4 <- dat_tab1[dat_tab1$jaro==10,] 
vyber4  #podvme se na nj

# mno a pokud chcete vbr bez konkrtnch hodnot tak je teba zadat != 
vyber5 <- dat_tab1[dat_tab1$jaro!=10,] 
vyber5 #podvme se na nj

# Hodnoty si mu i uspodat - pokud s nimi chci dle nco dlat, 
# tak pomoc ipeky uloit jako novou datovou tabulku

sort(dat_tab1$jaro)



####Seznamy####
# Vektory, matice i datov tabulky mohu skldat do seznam pomoc funkce list
# definuji seznam

sez1 <- list()

# Do listu narvu ti matice - pomoc dvojit hranat zvorky

sez1[[1]] <- mat1
sez1[[2]] <- mat2
sez1[[3]] <- mat3
sez1 #prohldnu si ji
class(sez1) #zkontroluji typ

# Vbry jsou analogick vbrm z vektor a matic,
# pklad vybere z tabulky 2, sloupec 2, dky 1-10

sez1[[2]][1:10,2]

# Jednotliv objekty v listu mu pojmenovat:

names(sez1) <- c("tabulka1", "tabulka2", "tabulka3")
sez1 #zkontroluji vsledek


# Podle jmen mu pomoc symbolu $ vybrat hodnoty

sez1$tabulka2[1:10,2]

# Na vbr mu aplikovat funkce, zde prmr z pedchozho vbru

mean(sez1$tabulka2[1:10,2])

# Do seznam mu poskldat vechny typy objekt (a to vetn seznam) 
# a vytvoit v nm sloitou strukturu seznam v seznamech

sez2 <- list()
sez2[[1]] <- sez1
sez2[[2]] <- dat_tab1
names(sez2) <- c("seznam1","datova_tabulka1")
sez2 #podvejme se na ni

# Statistick funkce maj komplikovan seznamy jako vstupy, proto je teba 
# bt schopen se v nich orientovat

sez2$seznam1$tabulka2[,2] #dotaz na matici
sez2$datova_tabulka1$jaro #dotaz na datovou tabulku




###### R potvrt (histogram)######

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

# nejprve si vytvome datov struktury z pedchozch lekc

c1 <- c(50, 14, 57, 145, 79, 9, 357, 63, 48, 10, 83, 40, 10, 10, 18, 61, 19, 38, 98, 93, 44)
c1
c4 <- c(80, 102, 142, 92, 102, 72, 363, 51, 102, 113, 159, 127, 163, 60, 63, 99, 208, 549, 151, 144, 65)
c4
mat1 <- cbind(c1,c4)
mat1
class(mat1)

####Histogram####
# K tvorb histogram pouvme pkaz hist().
# Pehledov info zde: http://portal.matematickabiologie.cz/index.php?pg=zaklady-informatiky-pro-biology--vypocetni-matematicke-systemy--vyuka-jazyka-r--grafika-v-r--high-level-funkce--hist

?hist #zjistme, co meme

hist(c1)

# prava kategori se dje atributem breaks="nzev" nebo potem 1-6

hist(c1, breaks = "Scott")

# chci-li na ose Y relativn etnosti, musm zadat freq=FALSE

hist(c1, freq=FALSE)

# chci-li je vypsat, pak pouiji atribut labels=TRUE

hist(c1, labels=TRUE)

# zkladn grafiku histogramu lze ovldat stjn jako u box-plot 
# atributy main, xlab, ylab a col, raf dopluje atributem density a jej sklon angle:

hist(c1, freq=FALSE, labels=TRUE, density=7, angle = 135, col="green", xlab="jaro", main = "Relativn rozdlen etnost")

# vstupn hodnoty zskm funkc (hist())

(hist(c1)) 

# kumulativn histogram pmo R neum a je teba pout nsledujc fintu:

muj_histo <- hist(c1) #ulo vsledn informace z histogramu

muj_histo # zkontrolujeme vzhled uloenho textovho vstupu

# vstupem je tedy seznam typu "histogram" o 6 objektech a jednm z nich je vektor counts 

muj_histo$counts <- cumsum(muj_histo$counts) #pepe hodnoty frekvenc vektoru count

plot(muj_histo, main = "Mj kumulovan histogram", ylab = "poet", xlab = "jaro") #vytvome nov graf

# Dal monost je naten balku lessR a pouit funkce histogram() 
# s pslunm atributem (samozejm to pjde a po instalaci danho package)

library(lessR)

Histogram(c1, cumul="on", main = "Mj kumulovan histogram", ylab = "poet", xlab = "jaro")

####Sloupcov grafy####
# k tvorb sloupcovho grafu slou funkce barplot()

barplot(c1)

# k zkladn grafick prav slou dve poznan atributy main, xlab, ylab, 
# col, density, angle
# jak lze graf upravit je popsho dole zde: http://portal.matematickabiologie.cz/index.php?pg=zaklady-informatiky-pro-biology--vypocetni-matematicke-systemy--vyuka-jazyka-r--grafika-v-r--high-level-funkce--barplot

####Sloupcov grafy s vce promnnmi####
# To je trochu oek, kter ale dl problmy i v MS Excel. eknm, e chci graficky 
# porovnat podle lokalit men na jae a na podzim

barplot(mat1) # to urit nen ono

# musm prohodit sloupce a dky

mat1t <- t(mat1) #transponoval jsem

barplot(mat1t) # to u je lep, ale souet konduktivit je z logiky vci blbost, 

# musm je dostat vedle sebe atributem beside=TRUE

barplot(mat1t, beside=TRUE) # to u je lep

# Vsledn graf musme samozejm upravit pomoc atribut, kter u znme nebo si je 
# dohledme zde: http://portal.matematickabiologie.cz/index.php?pg=zaklady-informatiky-pro-biology--vypocetni-matematicke-systemy--vyuka-jazyka-r--grafika-v-r--high-level-funkce--barplot

barplot(mat1t, beside=TRUE, main = "porovnn konduktivity na lokalitch", xlab="lokality", ylab="konduktivita", names.arg=c(1:21))




###### R popt (posouzen normality)######

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

library(readxl)

data <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/data1.xlsx")
# data <- read_excel("E:/R/data1.xlsx") # cesta k datm na Vaich flekch

# Nejprve je teba se podvat na histogram (viz pedchoz lekce - zkuste sami)

####Q-Q plot####
# Okometrick posouzen normality pomoc Q-Q grafu funkc qqnorm() a proloen linie 
# normlnho rozdlen funkc qqline().
# Testujeme promnnou pH1.

qqnorm(data$pH1, pch = 1, main="Q-Q plot") # atribut pch uruje symbol (1=koleko)

qqline(data$pH1, col = "red", lwd = 1) # atribut lwd udv ku ry

####ikmost a piatost####
# Nejprve je teba nainstalovat package e1071

library(e1071)

# Pro ikmost bude pouito funkce skewness

skewness(data$pH1)

# vsledn hodnota je 0.5244, jej rozdl od normality lze testovat - vzorec s tabulkou kritickch hodnot je zde:
# http://mvpprograms.com/help/mvpstats/distributions/SkewnessCriticalValues
# Pro alfa 95% (p=0.05) je kritick hodnota piblin 1.03 (mm 21 men a ne 20, take k.h. bude o fous men),
# 0.5244 je vrazn men ne 1.03, H0 nemohu zamtnout a tedy pH1 nen ikm

# Pro piatost bude pouito funkce kurtosis

kurtosis(data$pH1)

# vsledn hodnota je -1.0814 (je zporn = rozdlen smuje k plochosti), jej rozdl od normality lze
# testovat - vzorec s tabulkou kritickch hodnot je zde:
# http://mvpprograms.com/help/mvpstats/distributions/KurtosisCriticalValues
# Pro alfa 95% (p=0.05) je kritick hodnota piblin -1.27 (mm 21 men a ne 20, take k.h. bude o fous vt),
# -1.0814 je men (v absolutn hodnot) ne -1.27, H0 nemohu zamtnout a tedy pH1 nen ploch

####Shapiro-Wilks test normality####
# Zkladem testu je porovnn mch dat s teoretickmi hodnotami mch hodnot, kdyby tytomly normln rozdlen,
# testuje se tedy rozdl mch dat od normlnho rozdlen
# H0: nen rozdl mezi rozdlenm mch dat a normlnm rozdlenm
# hladina vznamnosti alfa = 95% (p=0.05) 

shapiro.test(data$pH1)

# W=0.918 a p = 0.08
# p je vt ne 0.05 (je 92%) a tedy H0 nemohu zamtnout = rozdl mezi mmi daty a normlnm rozdlenm nen




###### R poest (t-testy a F-test)######

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

library(readxl)

data <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/data1.xlsx")
# data <- read_excel("E:/R/data1.xlsx") # cesta k datm na Vaich flekch

####Jednovbrov t-test####

# Vechny t-testy meme vypotat pomoc funkce t.test()
?t.test

# Testujeme, jestli se prmrn hodnota men pH na jae (promn pH1)
# li od oekvanho prmru 4.2; musme tedy zadat promnou, teoretick prmr a jestli 
# potme oboustrann nebo jednostrann t-test (abysme si ukzali vliv toho, co testuji)
# nejprve pro oboustrann test:
# H0: nen rozdl mezi prmrem hodnoty nmi mench dat a teoretickou hodnotou prmru 4.2
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

t.test(data$pH1, mu=4.2, alternative = "two.sided") #oboustrann test (automaticky nastaveno)

# vsledek: t=1.50, p=0.1488
# H0 nemohu zamtnout a tedy prmr mch dat se na stanovan hladin vznamnosti neli
# od teoretick hodnoty 4.2.

# A te u jen rychle cvin posoudme vsledky jednostrannch test

t.test(data$pH1, mu=4.2, alternative = "greater") #jednostrann (H0: mj prmr je men nebo roven mu, HA: mj prmr je vt ne mu)

t.test(data$pH1, mu=4.2, alternative = "less") #jednostrann (H0: mj prmr je vt nebo roven mu, HA: mj prmr je men ne mu)

# vimte si, e jejich vsledky jsou v hodnot t a df stejn (mm stejn prmry, poty 
# men i SE) - p je ale vrazn odlin, protoe tch 95% u alfa se rozdluje pokad jinak,
# proto je teba se dobe zamyslet nad tm, co pesn chci testovat


####Prov t-test####
# Zadvm ob promnn a atribut paired = TRUE
# Li se prvn a druh men pH?
# H0: nen rozdl mezi pH menm na jae (pH1) a v asnm lt (pH2)
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

t.test(data$pH1, data$pH2, paired = TRUE)

# vsledek: t=-4.87, p = 9.214e-05
# H0 na hladin vznamnosti alfa=95% zamtm a tedy men na jae a v asnm lt se li- 
# v asnm lt je vy (t je zporn, nebo jsem v itateli odetal vt hodnotu pH2 
# od men hodnoty prmru pH1)


####Dvouvbrov t-test####

# Ukeme si nov zpsob zadn promnn podle faktoru,
# k tomu se pouv symbol ~ (Alt + 126)
# Testuji rozdl v pH1 mezi vbry identifikovanmi ve sloupci bohatost, tedy se ptm, jestli
# se li prmrn pH meen na jae (pH1) mezi lokalitami druhov bohatmi a chudmi
# H0: pH men na jae se neli mezi lokalitami druhov bohatmi a chudmi
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

t.test(data$pH1~data$bohatost)

# vsledek: t=3.74, p=0.0016
# H0 zamtm, rozdl na hladin vznamnosti alfa=95% existuje (p je men ne 0.05).

# Pouit atributu var.equal=TRUE - t.test implicitn pot test pro rozdln variance
# obou prmr, pokud se variance neli, je teba zadat ve uveden parametr var.equal=TRUE

t.test(data$pH1~data$bohatost, var.equal=TRUE) #vimte si rozdlu ve vsledku

# vsledek: t=3.79, p=0.0012
# H0 zamtm, rozdl na hladin vznamnosti alfa=95% existuje (p je men ne 0.05).
# Jen pro zopakovn rozhodovn o H0 s ohledem na stanoven alfa:
# Vimte si, e na hladin vznamnosti alfa=99.9% bych H0 zamtnout nemohl,
# nebo p=0.0012, je tedy vt ne 99.9% (0.0010)


####F-test####
# F-test se skrv pod oznaenm funkce var.test()

?var.test

# Otestujme rozdly ve varianci mezi druhov bohatmi a chudmi lokalitami pro pH1
# H0: rozptyl (variance) v pH1 se mezi druhov bohatmi a chudmi lokalitami neli
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

var.test(data$pH1~data$bohatost)

# vsledek: F=1.73, p=0.405
# H0 nezamtm a uzavrm, e variance se mezi obma skupinami neli

# Podle H0 lze pout omezen v atributu alternative, stejn jako u t-testu.

# No a nezapomnejte se podvat, jak to reln vypad v grafu.

boxplot(data$pH1~data$bohatost, names=c("bohat", "chud"), main="pH na raelinitch (jaro)", xlab="vegetace", ylab="pH")